#include <avr/io.h>
#include "multiplex.h"
#include "sbit.h"

void set_number(int nr, int display) {
	if(nr==0) {
		FB[display] = 0b00111111+(SBIT(FB[display],7)<<7);
	} else if(nr==1) {
		FB[display] = 0b00000110+(SBIT(FB[display],7)<<7);
	} else if(nr==2) {
		FB[display] = 0b01011011+(SBIT(FB[display],7)<<7);
	} else if(nr==3) {
		FB[display] = 0b01001111+(SBIT(FB[display],7)<<7);
	} else if(nr==4) {
		FB[display] = 0b01100110+(SBIT(FB[display],7)<<7);
	} else if(nr==5) {
		FB[display] = 0b01101101+(SBIT(FB[display],7)<<7);
	} else if(nr==6) {
		FB[display] = 0b01111101+(SBIT(FB[display],7)<<7);
	} else if(nr==7) {
		FB[display] = 0b00000111+(SBIT(FB[display],7)<<7);
	} else if(nr==8) {
		FB[display] = 0b01111111+(SBIT(FB[display],7)<<7);
	} else if(nr==9) {
		FB[display] = 0b01101111+(SBIT(FB[display],7)<<7);
	}
}	

void set_display_number(uint16_t nr) {
	uint8_t n0, n1, n2, n3;
	if(nr<10) {
		n3=nr;
		
		set_number(0,0);
		set_number(0,1);
		set_number(0,2);
		set_number(n3,3);
	} else if(nr<100) {
		n3=nr%10;
		n2=(nr-(n3))/10;
		
		set_number(0,0);
		set_number(0,1);
		set_number(n2,2);
		set_number(n3,3);
	} else if(nr<1000) {
		n3=nr%10;
		n2=((nr-(n3))/10)%10;
		n1=((nr-(n2*10)-n3)/100);
		
		set_number(0,0);
		set_number(n1,1);
		set_number(n2,2);
		set_number(n3,3);
	} else if(nr<10000) {
		n3=nr%10;
		n2=((nr-(n3))/10)%10;
		n1=((nr-(n2*10)-n3)/100)%10;
		n0=((nr-(n1*100)-(n2*10)-n3)/1000);
		
		set_number(n0,0);
		set_number(n1,1);
		set_number(n2,2);
		set_number(n3,3);
	}
}	

void set_fail(void) {
	FB[0] = 0b01110001;
	FB[1] = 0b01110111;
	FB[2] = 0b00000110;
	FB[3] = 0b00111000;
}		

void set_blank(void) {
	FB[0] = 0b00000000;
	FB[1] = 0b00000000;
	FB[2] = 0b00000000;
	FB[3] = 0b00000000;
}	

void set_wait(void) {
	FB[0] = 0b00110000;
	FB[1] = 0b00000000;
	FB[2] = 0b00000000;
	FB[3] = 0b00000110;
}	