#define F_CPU 8000000L

#include <avr/io.h>
#include <util/delay.h>
#include "sbit.h"
#include "io_label.h"
#include "timer0.h"
#include "timer1.h"
#include "display.h"

int main(void)
{
	SEG_DDR = 0b11111111;
	SEL_DDR = 0b00101111;
	
	BUT1_PULL = true;
	
	timer0_init();
	timer1_init();
	
	timer1_var_enabled = false;
	
	set_blank();
	
	uint8_t step=0;
	
	
    while(1)
    {
		if(step==0) {
			timer1_var=0;
			while(!BUT1);
			_delay_ms(300);
			while(BUT1);
			set_wait();
			_delay_ms(300);
			
			step=1;
		}		
		if(step==1) {
			uint16_t ms;
			ms=0;
			while ((ms<(uint16_t)((timer1_rand*70L)+300L))&&(step!=0)) {
				_delay_ms(10);
				if(BUT1) {
					set_fail();
					_delay_ms(500);
					step=0;
				}
				ms++;
			}
			if(step!=0) step=2;
		}			
		if(step==2) {
			LED1 = true;
			timer1_var_enabled = true;	
			while((!BUT1)&&(!(timer1_var>9999)));
			timer1_var_enabled = false;	
			if(timer1_var>9999) {
				set_fail();
			} else {
				set_display_number(timer1_var);
			}
			LED1 = false;
			_delay_ms(500);
			step=0;
		}
		
    }
	
	
}