#include <avr/io.h>
#include <avr/interrupt.h>

void timer1_init(void) {
  // Timer 1 konfigurieren
  TCCR1B = (1<<CS10) | (1<<CS11); // Prescaler 64
 
  TCNT1 = 65411; // -> Preload
 
  // Overflow Interrupt erlauben
  TIMSK |= (1<<TOIE1);
 
  // Global Interrupts aktivieren
  sei();
}



uint32_t volatile timer1_var;
uint8_t volatile timer1_var_enabled;
uint16_t volatile timer1_rand; //between 0&100

ISR(TIMER1_OVF_vect)
{
  // Interrupt jede ms
  TCNT1 = 65411; //B1E0 -> Preload
  
  if (timer1_var_enabled==1)  {
	timer1_var += 1;
  }  
  
  if(timer1_rand<100) {
	  timer1_rand++;
  } else {
	  timer1_rand = 0;
  }
}